// http://www.sist.ac.jp/~suganuma/kougi/other_lecture/SE/ 
// Aconjugate_j.txt 狤z@Ɋ֘AJavavO
// Rs[āAu`̉Kpɉρ@ 2008.10.08 H.Kimura
/*          coded by Y.Suganuma     */
/****************************/
/*     ֐lCW̌vZ */
/****************************/

// import FitnessFunction ;



public class Kansu {
	public FitnessFunction objectiveFunc   ;
	int param_dim ;
	double delta ; // ŋߎ̂ŁA̍̕
	//--------RXgN^
	Kansu (FitnessFunction InpFitnessFunction, double d ) {
		objectiveFunc = InpFitnessFunction ;
		objectiveFunc.Init() ;
		delta = d ;
		if( delta == 0 ){ delta = 0.00001;}
		//---------Tׂp[^̎ݒ
		param_dim = objectiveFunc.GetParameterDimension() ;
	}

	// ^ꂽ_xCdxk*dxi񂾓_ɂ֐lvZ
	double snx(double k, double x[], double dx[])
	{
		double param[] = new double[param_dim]; // p[^̉
		for( int index= 0; index < param_dim; index++ ){
			param[index] = x[index] + (k * dx[index]) ;
		}
		return( objectiveFunc.evaluate( param ) );
	}

	//------------֐̔iߎj
	//             dx[] ֊i[
	void dsnx(double x[], double dx[])
	{
		double param[] = new double[param_dim]; // p[^̉
		double f_x = objectiveFunc.evaluate( x ) ;
		for( int index= 0; index < param_dim; index++ ){
			for( int i= 0; i < param_dim; i++ ){
				param[i] = x[i] ;
			}
			param[index] += delta ;
			dx[index] = (objectiveFunc.evaluate( param )  - f_x ) / delta ;
		}
	}
}
